! This program calculates Time-lags (in micro-sec) and mod(del-n-gamaa/del-Tb) as
! function of Energy(in keV). Variaion of coronal heating rate is taken into account 

  implicit none

         !------------------------------------------------------------------------
         !--------- declaration of variables, functions etc.----------------------
         !------------------------------------------------------------------------
         
         integer :: i, j, n, cn, iter=1, iref

         character(len = 100) :: out1, out2

         real*8 :: enmin, enmax, nwenmin, nwenmax, den, Eref
         real*8 :: max, kte, ktb, aa, bb, omgtc, omga, freq
         real*8 :: ktberg ! the variable ktb converted in ergs 
         real*8 :: rdelte= 1., idelte= 0., rdeltb=0., ideltb=0.
         real*8 :: k1, k2, k3, eta, eta_cal, v_c, hex0, beta,tau
         real*8 :: compr_te, compr_tb, compj_te, compj_tb
         real*8 :: sum1=0.,sum4=0., sum11=0., sum44=0., cal2                
         real*8 :: eps=1.0d-5, sigmat=6.65d-25, sigma= 5.67d-5, k=1.38d-16 
         real*8 :: mec2=511.0, pi=3.14159, af, Lf, h= 6.626d-27, cc=3.0d10
         ! note cc:velocity of light; af,Lf are actually a and L in eq1 of paper
         real*8,dimension(4000) :: a,b,c,r,u,x, ri,en
         real*8,dimension(4000) :: a1,c1,r1,im1  
         real*8,dimension(4000) :: a2,c2,r2,im2,a_tbte,c_tbte    
         real*8,dimension(4000) :: a3,c3,r3,im3,a_etb,c_etb,r_etb  
         real*8,dimension(0:4000) :: nwen,nwdlen
         real*8,dimension(4000) :: ngama_1, ngama_2, ngama, ngama2, ngama21

         
         complex*16 :: compi,denom,dte,sum2=(0.,0.),sum3=(0.,0.),sum22,sum33
         complex*16 :: cal1, delte, delte1, deltb, deltb1, delhex
         complex*16,dimension(4000) ::b_tbte,u_tbte  
         complex*16,dimension(4000) :: w1, r_tbte        
 
    
         !----------------------------------------------------------------------------
         !--------------------Reading data from readme file-------------------------
         !-------------------------------------------------------------------------

         
         open (10, file = "input-timelag-corona.txt")
         read(10,*) n, cn, enmin, enmax
         read(10,*) eps
         read(10,*) tau, kte, ktb
         read(10,*) af, Lf, freq,  eta
   !      read(10,*) iter
         read(10,*) out1, out2



         !-------------------------------------------------------------------------
         !                 SECTION1: calculation ngama and its derivatives
         !-------------------------------------------------------------------------
         ktberg = ktb*(1.6e-9)
         Eref=4.0
         omga=2.*pi*freq
         max= tau + tau**2
         omgtc = (Lf*omga)/(cc*tau) ! calculated from deails after eq1 (read next 2 lines)

         delte =cmplx(rdelte, idelte)
         deltb =cmplx(rdeltb, ideltb)

         compi=(0,1)

         den = (enmax - enmin)/n
         nwenmin = (10**(enmin)) 
         nwenmax = 10**(enmax)


         do i=0, n-1
            en(i+1)= enmin + i*den
         end do

         do i=1,n
            nwen(i)= 10**en(i)
            if(nwen(i) .le. Eref)iref=i
         end do

     
         ! obtaining new differentials, we call nwdleni
         do i=1,n-1
            nwdlen(i)= nwen(i+1)- nwen(i)
         end do

         nwdlen(n)= nwdlen(n-1)                           !we put it by hand

     
          aa=((6.0*pi*af*af*mec2*omgtc)*((1.6e-9)**3))/(((af+Lf)**3 - (af)**3)*(h**3)*cc*cc*omga)
          bb=(aa*ktb*max)/(2.0*kte*max + mec2)

         ! we use following 2 relations 
         ! for further calculation we require nwen(0) and  nwdlen(0) so  we use following
         ! 2 relations  nwen(n+1)/nwen(n) =  nwen(n)/nwen(n-1) and
         ! nwdlen(n+1)/nwen(n+1) =  nwdlen(n)/nwen(n1) giving

         nwen(0) =(nwen(1)*nwen(1))/nwen(2)        
         nwdlen(0) =  (nwen(0)*nwdlen(1))/nwen(1)
 
         
         a(1)= ( kte - nwdlen(1))* nwen(1)*nwen(1)*nwdlen(1)

         b(1)=  (2.*(nwen(1)- kte) -mec2/max)*nwdlen(1)*nwdlen(1)*nwdlen(0) +&
                  ( nwdlen(1)*nwdlen(1)- kte*(nwdlen(1)+nwdlen(0)))*nwen(1)*nwen(1)
 
         c(1)= kte*nwen(1)*nwen(1)*nwdlen(0)

         r(1)=  -(aa*nwen(1)*nwen(1)*nwdlen(1)*nwdlen(1)*nwdlen(0))/(exp(nwen(1)/ktb) -1) -  &
                   ( (kte - nwdlen(1))*nwen(1)*nwen(1)*nwdlen(1))*(bb*nwen(0))
         
         do i=2,n
               a(i)= ( kte - nwdlen(i))* nwen(i)*nwen(i)*nwdlen(i)

               b(i)=  (2.*(nwen(i)- kte) -mec2/max)*nwdlen(i)*nwdlen(i)*nwdlen(i-1) +&
                       ( nwdlen(i)*nwdlen(i)- kte*(nwdlen(i)+nwdlen(i-1)))*nwen(i)*nwen(i)

               c(i)= kte*nwen(i)*nwen(i)*nwdlen(i-1)

               r(i)=  -(aa*nwen(i)*nwen(i)*nwdlen(i)*nwdlen(i)*nwdlen(i-1))/(exp(nwen(i)/ktb) -1) 
               
            end do

   
         !To calculate ngama we call the function 'tridag' which uses values 
         !of coefficients a(i),b(i),c(i),r(i) and returns 'u(i)' which is ngama
         
         call tridag(a,b,c,r,u,n)

         
        ! finding first derivatives of function u(i) [i.e. n_gama]
         do i = 1, n-1
            ngama_1(i) = (u(i+1)-u(i))/(nwdlen(i))
         end do

        
        do i = 1, n-1
            ngama2(i)= ((u(i+2)-u(i+1))/(nwdlen(i)*nwdlen(i+1))) -&
                 ((u(i+1)-u(i))/(nwdlen(i)*nwdlen(i)))
         end do

         
        do i = 1, n-2  ! note we've increased i by 1 on RHS aswe dont have value of u(i-1) when i=1
             ngama21(i)=  (u(i+2)*nwdlen(i) - u(i+1)*(nwdlen(i+1)+nwdlen(i)) + u(i)*nwdlen(i+1)) /&
                     (nwdlen(i+1)*nwdlen(i+1)*nwdlen(i))
             end do
         !----------------------------------------------------------------------------
         !                   SECTION2 solving equ7 for general case  
         !----------------------------------------------------------------------------

         ! calculating different coeffs when delte and deltb both variy. These are labelled
         !as a_tbe(i), b_tbe(i) etc. Note b_tbe and output u_tbe are complex other are real

         do j=1,n-2
            ngama(j)=u(j) !beacuse for subroutine 'ctridag' argument is 'u' not 'ngama' 
         end do

         do i=1,n-2
             
                a_tbte(i)= (kte*ngama(i) -(ngama(i) + (2.0*kte*ngama_1(i)))*nwdlen(i) )*nwdlen(i)

                b_tbte(i)= (ngama(i) + 2.0*kte*ngama_1(i))*(nwdlen(i)*nwdlen(i)) - &
                             ngama(i)*kte*(nwdlen(i) + nwdlen(i-1)) - &
                                        (aa*nwdlen(i)*nwdlen(i)*nwdlen(i-1))/((exp(nwen(i)/ktb)-1.0)) + &
                             (compi*omgtc*mec2*ngama(i)*nwdlen(i)*nwdlen(i)*nwdlen(i-1))/(nwen(i)*nwen(i)) 
                        
                c_tbte(i)= ngama(i)*kte*nwdlen(i-1)
            
                r_tbte(i)= (kte*nwdlen(i)*nwdlen(i)*nwdlen(i-1)*delte)*((2.0*ngama(i)/(nwen(i)*nwen(i)))-(ngama21(i))) + &
                               (aa*nwen(i)*nwdlen(i)*nwdlen(i)*nwdlen(i-1)*deltb)/ &
                                ((ktb)*(exp(nwen(i)/ktb)-1.0)*(exp(-nwen(i)/ktb) - 1.0)) 
             end do

 
         call ctridag(a_tbte,b_tbte,c_tbte,r_tbte,u_tbte,cn-2)

        
        
     !*****************************************************************************************
     !--------------- VARIATION OF CORONAL HEATING RATE   ----- ------------------
     !******************************************************************************************
       
          
          k1 = ktberg/k
          k2 = 4.*pi*(af**2)*sigma
          k3 = (max*omgtc)/omga

          beta = (sigmat*cc)/mec2

          v_c = (4.0/3.0)*pi*((af+Lf)**3 - (af)**3)


         do i=1,n-2
             sum1 = sum1 + ngama(i)*nwen(i)*nwdlen(i)
             sum2 = sum2 + ngama(i)*u_tbte(i)*nwen(i)*nwen(i)*nwdlen(i)
             sum3 = sum3 + ngama(i)*u_tbte(i)*nwen(i)*nwdlen(i)
             sum4 = sum4 + ngama(i)*nwen(i)*nwen(i)*nwdlen(i)
          end do

          hex0 = (sigmat*cc*(4.0*kte*sum1 - sum4))/mec2

          delhex =( beta*(4.0*kte*sum3 - sum2) + delte*(4.0*beta*kte*sum1 - &
                  (3.0/2.0)*compi*omga*kte) )/hex0

          eta_cal= (k2*(k1**4)*k3)/(v_c*sum1*1.6e-9)

          if (iter .eq. 0) goto 200 
       !----------------------------------------------------------------------------------

100       continue
          
         do i=1,n-2
             
                a_tbte(i)= (kte*ngama(i) -(ngama(i) + (2.0*kte*ngama_1(i)))*nwdlen(i) )*nwdlen(i)

                b_tbte(i)= (ngama(i) + 2.0*kte*ngama_1(i))*(nwdlen(i)*nwdlen(i)) - &
                             ngama(i)*kte*(nwdlen(i) + nwdlen(i-1)) - &
                                        (aa*nwdlen(i)*nwdlen(i)*nwdlen(i-1))/((exp(nwen(i)/ktb)-1.0)) + &
                             (compi*omgtc*mec2*ngama(i)*nwdlen(i)*nwdlen(i)*nwdlen(i-1))/(nwen(i)*nwen(i)) 
                        
                c_tbte(i)= ngama(i)*kte*nwdlen(i-1)
            
                r_tbte(i)= (kte*nwdlen(i)*nwdlen(i)*nwdlen(i-1)*delte)*((2.0*ngama(i)/(nwen(i)*nwen(i)))-(ngama21(i))) + &
                               (aa*nwen(i)*nwdlen(i)*nwdlen(i)*nwdlen(i-1)*deltb)/ &
                                ((ktb)*(exp(nwen(i)/ktb)-1.0)*(exp(-nwen(i)/ktb) - 1.0)) 
             end do

 
         call ctridag(a_tbte,b_tbte,c_tbte,r_tbte,u_tbte,cn-2)


   
      !-----------------------------------------------------------------------------------------   
         ! one could initialize sum11 etc outside the iteration loop but that'd have given wrong
         ! result. Be VERY VERY careful while initializing 
      !-----------------------------------------------------------------------------------------

         sum11=0.       
         sum22=(0.,0)
         sum33=(0.,0)
         sum44=0.
         do i=1,n-2
             sum11 = sum11 + ngama(i)*nwen(i)*nwdlen(i)
             sum22 = sum22 + ngama(i)*u_tbte(i)*nwen(i)*nwen(i)*nwdlen(i)
             sum33 = sum33 + ngama(i)*u_tbte(i)*nwen(i)*nwdlen(i)
             sum44 = sum44 + ngama(i)*nwen(i)*nwen(i)*nwdlen(i)
          end do

          delte1 = (hex0*delhex + beta*(sum22 - 4.0*kte*sum33))/(4.0*beta*kte*sum11 -&
                     (3.0/2.0)*compi*omga*kte)

          deltb1 = (eta*v_c*sum33*1.6e-9)/((k1**4)*(4.0*k2)*k3)       !1kev=1.6e-9 ergs
          
          compr_te=(real(delte1)-real(delte))/real(delte1)
          compj_te=(Imag(delte1)-Imag(delte))/Imag(delte1)   
          delte=delte1

          compr_tb=(real(deltb1)-real(deltb))/real(deltb1)
          compj_tb=(Imag(deltb1)-Imag(deltb))/Imag(deltb1)
          deltb=deltb1
         
          if( abs(compr_te) .gt. eps .or. abs(compj_te) .gt. eps  .or. abs(compr_tb) .gt. &
               eps .or. abs(compj_tb) .gt. eps)  goto 100
 
200       continue
           open(11,file= out1)
         do i=1,n-2
            write(11,*) nwen(i),((abs(u_tbte(i)))/(abs(delhex)))
         end do
         close(11)
         
         print *, 'etacal = ',eta_cal
     !******************************************************************************************
     !                  calculating phase lag between 2 energies     
     !-----------------------------------------------------------------------------
          do i=1,n-2
            w1(i)=conjg(u_tbte(iref))*(u_tbte(i))
            r1(i)=real(w1(i))
            im1(i)=imag(w1(i))
         end do
       
     !---------- using above information  phase lag is calculated:
     !----- when either of te or tb varies-------------------------------------
     !-note while writing in the file we have converted phase-lag in to time-lag
     !------------------------------------------------------------------------------

         open(51, file= out2)
         do i=1,n-2 
            write(51,*) nwen(i), (atan2(im1(i),r1(i))*1e6/(2.*pi*freq))
         end do
         close(51)

       end program


       !***************************************************************************
         SUBROUTINE ctridag(ca,cb,cc,cr,cu,cn)
      INTEGER cn,cNMAX
      REAL*8 ca(cn),cc(cn)
      complex*16 cb(cn),cu(cn),cr(cn)
      PARAMETER (cNMAX=5000)
      INTEGER j
      complex*16 bet,gam(cNMAX)
      if(cb(1).eq.0.)stop 'ctridag: rewrite equations'
      bet=cb(1)
      cu(1)=cr(1)/bet
      do 11 j=2,cn
        gam(j)=cc(j-1)/bet
        bet=cb(j)-ca(j)*gam(j)
        if(bet.eq.0.)stop 'ctridag failed'
        cu(j)=(cr(j)-ca(j)*cu(j-1))/bet
11    continue
      do 12 j=cn-1,1,-1
        cu(j)=cu(j)-gam(j+1)*cu(j+1)
12    continue
      return
      END
      !*************************************************************************
         SUBROUTINE tridag(a,b,c,r,u,n)
      INTEGER n,NMAX
      REAL*8 a(n),b(n),c(n),r(n),u(n)
      PARAMETER (NMAX=5000)
      INTEGER j
      REAL*8 bet,gam(NMAX)
      if(b(1).eq.0.)STOP 'tridag: rewrite equations'
      bet=b(1)
      u(1)=r(1)/bet
      do 11 j=2,n
        gam(j)=c(j-1)/bet
        bet=b(j)-a(j)*gam(j)
        if(bet.eq.0.)STOP 'tridag failed'
        u(j)=(r(j)-a(j)*u(j-1))/bet
11    continue
      do 12 j=n-1,1,-1
        u(j)=u(j)-gam(j+1)*u(j+1)
12    continue
      return
      END
